<template>
	<div class="dialog-container">
		<el-dialog :title="state.dialog.title" v-model="state.dialog.isShowDialog" width="769px"
			:close-on-click-modal="false" draggable destroy-on-close @close="onCancel">
			<el-form ref="DialogFormRef" :model="state.configForm" size="default" :rules="rules" label-width="150px" v-if="!props.showJinCheng">
				<el-row :gutter="35">
					<!-- <el-col :xs="24" :sm="24" :md="24" :lg="24" :xl="24" class="mb20">
						<el-form-item label="事件状态" prop="policeEventStatus">
							<el-select v-model="state.configForm.policeEventStatus" placeholder="请选择" style="width:100%" clearable>
								<el-option label="待处理" value="None" />
								<el-option label="处理中" value="Pending" />
								<el-option label="已处理" value="Over" />
							</el-select>
						</el-form-item>
					</el-col> -->
					<el-col :xs="24" :sm="24" :md="24" :lg="24" :xl="24" class="mb20">
						<el-form-item label="已采取措施" prop="actionTaken">
							<el-input v-model="state.configForm.actionTaken" placeholder="请输入" clearable></el-input>
						</el-form-item>
					</el-col>
					<el-col :xs="24" :sm="24" :md="24" :lg="24" :xl="24" class="mb20">
						<el-form-item label="处理情况及发展趋势" prop="actionTendency">
							<el-input v-model="state.configForm.actionTendency" placeholder="请输入" clearable></el-input>
						</el-form-item>
					</el-col>
					<el-col :xs="24" :sm="24" :md="24" :lg="24" :xl="24" class="mb20">
						<el-form-item label="进一步处置意见" prop="processedSuggestion">
							<el-input v-model="state.configForm.processedSuggestion" placeholder="请输入" clearable></el-input>
						</el-form-item>
					</el-col>
					<el-col :xs="24" :sm="24" :md="24" :lg="24" :xl="24" class="mb20">
						<el-form-item label="现场调度指导" prop="processedLocaleGuidance">
							<el-input v-model="state.configForm.processedLocaleGuidance" placeholder="请输入"
								clearable></el-input>
						</el-form-item>
					</el-col>
				</el-row>
			</el-form>
			<el-form class="clue-processing-container" v-else ref="DialogFormRef" :model="state.configForm">
				<el-card class="form-card">
				<el-descriptions :column="1" border>
					<el-descriptions-item label="线索类型">{{ state.configForm.policeEventType }}</el-descriptions-item>
					<el-descriptions-item label="线索标题">{{ state.configForm.name }}</el-descriptions-item>
					<el-descriptions-item label="线索内容">{{ state.configForm.reason }}</el-descriptions-item>
					<el-descriptions-item label="上报人">{{ state.configForm.empName }}</el-descriptions-item>
					<el-descriptions-item label="上报时间">{{ state.configForm.createdTime }}</el-descriptions-item>
					<el-descriptions-item label="联系人">{{ state.configForm.empName }}</el-descriptions-item>
					<el-descriptions-item label="联系方式">{{ state.configForm.contact }}</el-descriptions-item>
					<el-descriptions-item label="线索级别">{{ state.configForm.policeEventLevel }}</el-descriptions-item>
					<el-descriptions-item label="线索地点">{{ state.configForm.address }}</el-descriptions-item>
					<el-descriptions-item label="线索日期">{{ state.configForm.createdTime.split(' ')[0] }}</el-descriptions-item>
					<el-descriptions-item label="所属区域">{{ state.configForm.securityStationName }}</el-descriptions-item>
					<el-descriptions-item label="线索规模">{{ state.configForm.items?.scale }}</el-descriptions-item>
					<el-descriptions-item label="备注">{{ state.configForm.description }}</el-descriptions-item>
					<el-descriptions-item label="附件">
						<div v-if="JSON.parse(state.configForm.sceneUrl)?.length">
							<el-button 
							v-for="(url, index) in JSON.parse(state.configForm.sceneUrl)" 
							:key="index"
							size="small" 
							text 
							type="primary"
							@click="handlePreviewAttachment(url, index)"
							>
							附件{{ index + 1 }}
							</el-button>
						</div>
						<span v-else class="text-gray-400">无附件</span>
					</el-descriptions-item>
					<el-descriptions-item label="处理状态">
						<el-tag 
							:type="state.configForm.policeEventStatus === '已处理' ? 'success' : 'danger'"
							effect="light"
						>
							{{ state.configForm.policeEventStatus }}
						</el-tag>
					</el-descriptions-item>
					<el-descriptions-item label="处理意见">
						<el-input v-model="state.configForm.processedSuggestion" placeholder="请输入" type="textarea" clearable></el-input>
					</el-descriptions-item>
					<el-descriptions-item label="奖励积分">
						<el-input-number v-model="state.configForm.points" :min="0" :max="10"/>
					</el-descriptions-item>
					<el-descriptions-item label="处理人">{{ state.configForm.processedUserName }}</el-descriptions-item>
					<el-descriptions-item label="处置时间">{{ state.configForm.processedTime }}</el-descriptions-item>
				</el-descriptions>
				</el-card>
			</el-form>
			<template #footer>
				<span class="dialog-footer">
					<el-button @click="onCancel" size="default">取 消</el-button>
					<el-button type="primary" @click="onSubmit" size="default">{{ state.dialog.submitTxt }}</el-button>
				</span>
			</template>
		</el-dialog>
	</div>
	<!-- 添加预览弹窗 -->
	<el-dialog 
	v-model="previewVisible" 
	title="附件预览" 
	width="80%"
	top="5vh"
	>
	<div class="preview-container">
		<img 
		v-if="isImage(currentPreviewUrl)" 
		:src="currentPreviewUrl" 
		class="preview-image"
		/>
		<iframe
		v-else-if="isPdf(currentPreviewUrl)"
		:src="`https://docs.google.com/viewer?url=${encodeURIComponent(currentPreviewUrl)}&embedded=true`"
		class="preview-iframe"
		></iframe>
		<div v-else class="unsupported-type">
		不支持在线预览此类型文件，请下载查看
		<el-button 
			type="primary" 
			@click="handleDownload(currentPreviewUrl)"
		>
			下载文件
		</el-button>
		</div>
	</div>
	</el-dialog>
</template>

<script setup lang="ts" name="configDialog">
import { reactive, ref, defineAsyncComponent, nextTick, toRaw } from 'vue';
import { ElMessageBox, ElMessage } from 'element-plus';
import { ConfigApi } from '/@/api/api'
// 引入组件
const props = defineProps({
	showJinCheng: {
		type: Boolean,
		default: false
	},
})
// 添加状态和类型判断
const previewVisible = ref(false)
const currentPreviewUrl = ref('')
const currentPreviewIndex = ref(0)
// 定义子组件向父组件传值/事件
const emit = defineEmits(['refresh']);
// const showJinCheng = ref(import.meta.env.VITE_SHOW_JINCHENG_PROJECT);
// 定义变量内容
const topicDialogRef = ref();//新增主题弹窗
const state = reactive({
	tableData: {
		data: [] as any,
		total: 0,
		loading: false,
	},
	configForm: {
		id: '',
		actionTaken: '',
		actionTendency: '',
		processedSuggestion: '',
		processedLocaleGuidance: '',
		securityStationName: "",
		name: "",
		empName: "",
		sceneUrl: "[]",
		contact: "",
		policeEventStatus: "",
		policeEventLevel: "",
		address: "",
		reason: "",
		policeEventType: "",
		processedUserName: null,
		processedTime: null,
		createdTime: "",
		description: "",
		points: null,
		items: {
			eventDate: "",
			scale: "",
		}
	},
	dialog: {
		isShowDialog: false,
		type: '',
		title: '',
		submitTxt: '',
	},
});

const rules = reactive({
	policeEventStatus: [{ required: true, message: "请选择", trigger: "blur" }],
})
const DialogFormRef = ref()//表单form对象
// 打开弹窗
const openDialog = (type: string, row: targetDataType) => {
	if (type === 'edit') {
		let rowobj = JSON.parse(JSON.stringify(row))
		console.log('rowobj', rowobj)
		state.configForm = rowobj;
		state.dialog.title = '处理';
		state.dialog.submitTxt = '处 理';
		state.dialog.type = 'edit'
	} else {
		/**
		 * JS对象分为基础类型和引用类型，基础类型(Number, String, Boolean…)直接存储于栈中，引用类型(Object…)栈中存储指向存储在堆中的对象的指针。
		 * Object.assign() 拷贝的是属性值，如果源对象的属性值是一个指向对象的指针，那也只拷贝那个指针。所以如果对象的属性值为基础类型，对于通过Object.assign()拷贝的那个属性而言是深拷贝；如果对象的属性值为引用，对于通过通过Object.assign()拷贝的那个属性而言其实是浅拷贝的。
		 * Object.assign() 方法用于将所有可枚举属性的值从一个或多个源对象复制到目标对象。它将返回目标对象。
		 * 简单来说，就是Object.assign()是对象的静态方法，可以用来复制对象的可枚举属性到目标对象，利用这个特性可以实现对象属性的合并。
		 */
		state.configForm = Object.assign({});//新增重置空对象，基础类型是深拷贝，对象引用类型是浅拷贝
		state.dialog.title = '新增';
		state.dialog.submitTxt = '保 存';
		state.dialog.type = 'add'
	}
	state.dialog.isShowDialog = true;//打开弹窗-显示
};

const isImage = (url: string) => {
  return /\.(jpg|jpeg|png|gif|bmp|webp)$/i.test(url)
}

const isPdf = (url: string) => {
  return /\.pdf$/i.test(url)
}

const handlePreviewAttachment = (url: any, index: number) => {
  const actualUrl = typeof url === 'string' ? url : url.url
  if (!actualUrl) {
    ElMessage.warning('无效的附件链接')
    return
  }

  currentPreviewUrl.value = actualUrl
  currentPreviewIndex.value = index
  previewVisible.value = true
}

const handleDownload = (url: any) => {
  const actualUrl = typeof url === 'string' ? url : url.url
  const link = document.createElement('a')
  link.href = actualUrl
  link.download = `附件_${new Date().getTime()}`
  link.style.display = 'none'
  document.body.appendChild(link)
  link.click()
  document.body.removeChild(link)
}
// 关闭弹窗
const closeDialog = () => {
	state.dialog.isShowDialog = false;
	nextTick(() => {
		DialogFormRef.value?.resetFields();//清空表单，此项需加表单验证才能使用--关闭窗口重重输入框值
	});
};

// 取消
const onCancel = () => {
	closeDialog();
};
// 提交
const onSubmit = () => {
	DialogFormRef.value.validate((valid: any) => {
		if (valid) {
			if (state.dialog.type === 'edit') {
				//编辑保存
				let obj = {
					id: state.configForm.id,
					actionTaken: state.configForm.actionTaken,
					actionTendency: state.configForm.actionTendency,
					processedSuggestion: state.configForm.processedSuggestion,
					processedLocaleGuidance: state.configForm.processedLocaleGuidance,
					securityStationName: state.configForm.securityStationName,
					sceneUrl: state.configForm.sceneUrl,
					policeEventStatus: 'Over',
					processedUserName: state.configForm.processedUserName,
					processedTime: state.configForm.processedTime,
					createdTime: state.configForm.createdTime,
					description: state.configForm.description,
					points: state.configForm.points,
					items: state.configForm.items
				}
				ConfigApi().policeIncidentsEditApi(obj).then(response => {
					console.log('response返回', response)
					if (response.status == 200) {//成功才关闭窗口
						emit('refresh');//传递参数给父级
						closeDialog();
					}
				}).catch(erro => {
					console.log('erro错误', erro)
				})
			} else {
				//新增保存
				let obj = {
					actionTaken: state.configForm.actionTaken,
					actionTendency: state.configForm.actionTendency,
					processedSuggestion: state.configForm.processedSuggestion,
					processedLocaleGuidance: state.configForm.processedLocaleGuidance,
					securityStationName: state.configForm.securityStationName,
					name: state.configForm.name,
					empName: state.configForm.empName,
					sceneUrl: state.configForm.sceneUrl,
					contact: state.configForm.contact,
					policeEventStatus: 'None',
					address: state.configForm.address,
					reason: state.configForm.reason,
					policeEventType: state.configForm.policeEventType,
					processedUserName: state.configForm.processedUserName,
					processedTime: state.configForm.processedTime,
					createdTime: state.configForm.createdTime,
					description: state.configForm.description,
					points: state.configForm.points,
					items: state.configForm.items
				}
				// ConfigApi().policeIncidentsEditApi(obj).then(response => {
				// 	console.log('response返回', response)
				// 	if (response.success) {//成功才关闭窗口
				// 		emit('refresh');//传递参数给父级
				// 		closeDialog();
				// 	}
				// }).catch(erro => {
				// 	console.log('erro错误', erro)
				// })
			}

		}
	})
};
// 暴露变量
defineExpose({
	openDialog,
});
</script>

<style scoped lang="scss">
.dialog-container {
	.clue-processing-container {
	padding: 20px;
	max-width: 800px;
	margin: 0 auto;
	}

	.form-card {
	margin-top: 20px;
	}

	.action-buttons {
	margin-top: 20px;
	text-align: center;
	}

	.el-descriptions {
	margin-top: 20px;
	}

	.el-descriptions-item__label {
	width: 120px;
	font-weight: bold;
	}
}
.preview-container {
  display: flex;
  justify-content: center;
  align-items: center;
  min-height: 60vh;
}

.preview-image {
  max-width: 100%;
  max-height: 70vh;
  object-fit: contain;
}

.preview-iframe {
  width: 100%;
  height: 70vh;
  border: none;
}

.unsupported-type {
  text-align: center;
  padding: 20px;
}
</style>
